package markov;

import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.internet.MimeMessage;
import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.util.Arrays;
import java.util.Collection;
import java.util.Map;
import java.util.Properties;
import java.util.stream.Stream;

public class Mail {
    public static void main(String[] args) {
        int prefixLength = 3;

        Parser parser = new Parser();
        File parent = new File("C:\\Users\\admin\\Desktop\\emails");
        Stream<String> mails = Arrays.stream(parent.listFiles()).limit(500).map(file -> file.toPath()).map(path -> {
            try {

                MimeMessage m = new MimeMessage(Session.getDefaultInstance(new Properties()), Files.newInputStream(path));
                //System.out.println(m.getContentType());
//                return m.getContent().toString();
                return m;
            } catch (IOException | MessagingException e) {
                throw new RuntimeException(e);
            }
        }).filter(mimeMessage -> {
            try {
                return mimeMessage.getContentType().contains("text/plain");
            } catch (MessagingException e) {
                throw new RuntimeException(e);
            }
        }).map(m -> {
            try {
                return m.getContent().toString();
            } catch (IOException | MessagingException e) {
                throw new RuntimeException(e);
            }
        });
        Data data = Utils.parse(mails, prefixLength);

        Builder b = new Builder(prefixLength, data);
        Renderer r = new Renderer(data, Renderer.Options.FULL);
        Renderer r1 = new Renderer(data, Renderer.Options.NONE);
        Shortener shortener = new Shortener(data);

        for (int i = 0; i < 10; i++) {
            Collection<Map.Entry<Prefix, Decission>> sentence = b.random();
//            System.out.println(r1.render(sentence));
            String id = shortener.getId(sentence);
            System.out.println(id);
//            System.out.println(r.render(shortener.getSentence(id)));
        }
//        Collection<Map.Entry<Prefix, Token>> a = b.average();
//        System.out.println("average: " + r.render(a));
//        for (Map.Entry<Prefix, Token> e : a) {
//            System.out.println(e.getKey() + " -> " + data.fetch(e.getKey()));
//        }
//        System.out.println(data.dumpStats());
    }
}
