package markov;

import java.nio.charset.Charset;
import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.Base64;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class Shortener {

    private final Data data;

    public Shortener(Data data) {
        this.data = data;
    }

    public String getId(Collection<Map.Entry<Prefix, Decission>> sentence) {
        return fromInts(sentence.stream()
                .map(d -> d.getValue().getId()));

    }

    String fromInts(Stream<Integer> ints) {
        String cps = ints.map(i -> {
            System.out.println(i);
            return new String(Character.toChars(i));
        }).collect(Collectors.joining());
        return Base64.getEncoder().encodeToString(cps.getBytes());
    }

    Stream<Integer> toInts(String hash) {
        return new String(Base64.getDecoder().decode(hash.getBytes())).codePoints().boxed();
    }

    public Collection<Map.Entry<Prefix, Decission>> getSentence(String hash) {
        Integer[] ids = toInts(hash).toArray(Integer[]::new);

        Collection<Map.Entry<Prefix, Decission>> sentence = new ArrayList<>();
        Prefix prefix = new Prefix(new Token[0]);
        for (int id : ids) {
            Lookup lookup = data.fetch(prefix);
            Decission d = lookup.forId(id);
            sentence.add(new AbstractMap.SimpleEntry<>(prefix, d));
            prefix = prefix.slide(d.getToken(), data.getPrefixLength());
        }
        return sentence;
    }
}
