package markov;

import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.Collection;
import java.util.stream.Stream;

public class Utils {
    public static byte[] toByteArray(int value) {
        return ByteBuffer.allocate(4).putInt(value).array();
    }

    public static int fromByteArray(byte[] bytes) {
        return ByteBuffer.wrap(bytes).getInt();
    }

    public static Data parse(Stream<String> input, int prefixLength) {
        Collection<Integer> collectionDummy = new ArrayList<>();
        collectionDummy.add(prefixLength);
        return new Parser().parse(new Tokenizer().tokenize(input), collectionDummy).values()
                .stream().findFirst().get();
    }
}
